#ifndef RT_VK_FRAMEBUFFER_H
#define RT_VK_FRAMEBUFFER_H

#include <volk/volk.h>

typedef struct {
    VkFramebuffer framebuffer;
    uint32_t pass_idx;
} rt_framebuffer;

typedef struct {
    uint32_t index;
} rt_framebuffer_handle;

/* Reserve a slot, but don't actually create the framebuffer yet.
 * We can use this if we are unsure if the framebuffer will really be needed.
 */
rt_framebuffer_handle rt_reserve_framebuffer(void);

rt_framebuffer *rt_get_framebuffer(rt_framebuffer_handle handle);

#endif
